/* Program arithm.cc    */
/* By Harald Stauss     */
/* Last change 26.03.99 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include "tsa.h"

main(int argc, char *argv[])
{
  int           i, chn1, chn2, chny;
  unsigned long n, ndat;
  char          *fin,*fout,*ftin,*ftout;
  char          *pfin, *pfout, *pftin, *pftout;
  char          dowhat[256];
  REGIST        r;


  /* H e l l o   w o r l d */
  cout << "arithm ver.1.0 by H. Stauss, 1999 \n";

  /* A r r a y s   a l l o c i e r e n */
  fin=(char *)malloc(255); pfin=fin;
  fout=(char *)malloc(255); pfout=fout;
  ftin=(char *)malloc(255); pftin=ftin;
  ftout=(char *)malloc(255); pftout=ftout;

  /* P a r a m e t e r   e i n l e s e n */
  if (argc != 6)
    {
      cout << "Number of parameters wrong! \n";
      cout << "arithm f_in f_out ch1 ch2 +,-,*,/ \n";
      cout << "calculates ch1 +,-,*,/ ch2 and \n";
      cout << "adds a channel with the result at the end of the registration \n";
      cout << "f_in : name of input file (*.TSA, *.ASC). \n";
      cout << "f_out: name of output file (*.TSA, *.ASC). \n";
      goto ende;
    }
  strcpy(fin,argv[1]);
  strcpy(fout,argv[2]);
  strcpy(ftin,fin);
  strcpy(ftout,fout);
  pftin=strrchr(ftin,'.');
  for (i=0; pftin[i]; i++) pftin[i]=toupper(pftin[i]);
  pftout=strrchr(ftout,'.');
  for (i=0; pftout[i]; i++) pftout[i]=toupper(pftout[i]);

  printf("Input file : %s \n",fin);
  printf("Output file: %s \n",fout);

  sscanf(argv[3],"%d",&chn1);
  sscanf(argv[4],"%d",&chn2);
  cout << "channel numbers: " << chn1 << " and " << chn2 << "\n";
  strcpy(dowhat, argv[5]);
  /* E i n g a b e d a t e i e n   o e f f n e n */
  if (strcmp(pftin,".TSA")==0) r.ReadTSA(fin);
  if (strcmp(pftin,".ASC")==0) r.ReadASCII(fin,1);
  if ((strcmp(pftin,".TSA")!=0) && (strcmp(pftin,".ASC")!=0)) {
    cout << "File type for input file not recognized! \n";
    goto ende;
  }
  printf("Number of channels in file : %d  \n",r.n);
  
  if (chn1>=r.n || chn2>=r.n || chn1<0 || chn2<0) {
    cout << "channel number(s) out of range \n";
    goto ende;
  }

  chny=r.n;
  if (r.ch[chn1].n < r.ch[chn2].n)
    ndat=r.ch[chn1].n;
  else
    ndat=r.ch[chn2].n;

  r.AddChannel(ndat, r.ch[chn1].sr, 1e30, -1e30, 0, 0, "arithm", "units");

  /* M A I N L O O P  */
  for (n=0; n<ndat; n++) {
    if (!strcmp(dowhat, "+")) {
      //      cout << "+ \n";
      r.ch[chny].data[n]=r.ch[chn1].data[n]+r.ch[chn2].data[n];
      if (r.ch[chny].min>r.ch[chny].data[n]) r.ch[chny].min=r.ch[chny].data[n];
      if (r.ch[chny].max<r.ch[chny].data[n]) r.ch[chny].max=r.ch[chny].data[n];
    }
    else if (!strcmp(dowhat, "-")) {
      //      cout << "- \n";
      r.ch[chny].data[n]=r.ch[chn1].data[n]-r.ch[chn2].data[n];
      if (r.ch[chny].min>r.ch[chny].data[n]) r.ch[chny].min=r.ch[chny].data[n];
      if (r.ch[chny].max<r.ch[chny].data[n]) r.ch[chny].max=r.ch[chny].data[n];
    }
    else if (!strcmp(dowhat, "*")) {
      //      cout << "* n";
      r.ch[chny].data[n]=r.ch[chn1].data[n]*r.ch[chn2].data[n];
      if (r.ch[chny].min>r.ch[chny].data[n]) r.ch[chny].min=r.ch[chny].data[n];
      if (r.ch[chny].max<r.ch[chny].data[n]) r.ch[chny].max=r.ch[chny].data[n];
    }
    else if (!strcmp(dowhat, "/")) {
      //      cout << "/ \n";
      if (r.ch[chn2].data[n]!=0) {
	r.ch[chny].data[n]=r.ch[chn1].data[n]/r.ch[chn2].data[n];
	if (r.ch[chny].min>r.ch[chny].data[n]) r.ch[chny].min=r.ch[chny].data[n];
	if (r.ch[chny].max<r.ch[chny].data[n]) r.ch[chny].max=r.ch[chny].data[n];
      }
      else {
	r.ch[chny].data[n]=0;
	cout << "division by 0 in line " << n+1 << "\n";
      }
    }
  } /* endfor */

  /* D a t e i   s c h r e i b e n */
  if (strcmp(pftout,".TSA")==0) r.WriteTSA(fout);
  if (strcmp(pftout,".ASC")==0) r.WriteASCII(fout);
  if ((strcmp(pftout,".TSA")!=0) && (strcmp(pftout,".ASC")!=0)) {
    printf("File type for output not recognized! \n");
    goto ende;
  }

 ende:
  free(fin);free(ftin);free(fout);free(ftout);
  return(0);
} /* Ende von main */
