/* Program  rectify.cc      */
/* By Harald Stauss         */
/* Last change 12 Sep. 1997 */

#include <ctype.h>
#include "tsa.h"

main(int argc, char *argv[])
{
  short    i,chn;
  float    sr;
  unsigned long     n;
  char     *fin,*fout,*ftin,*ftout, *pftin, *pftout;
  REGIST   r;

  /* H e l l o    W o r l d */

  printf("rectify version 1.1 by H. Stauss, 1997 \n");

  /* A r r a y s   a l l o c i e r e n */
  fin  = new char[256];
  fout = new char[256];
  ftin = new char[256];
  ftout= new char[256];

  if ((argc != 4) && (argc != 5))
    {
      cout << "Number of parameters wrong! \n";
      cout << "Rectifies channel number chn \n";
      cout << "RECTIFY fin fout chn [sr] \n";
      cout << "fin    : name of input file (*.asc). \n";
      cout << "fout   : name of output file (*.asc). \n";
      cout << "chn    : channel to be rectified. \n";
      cout << "[sr]   : sr if input file ASCII \n";
      goto ende;
    }

  /* Eingabedatei oeffnen */
  strcpy(fin,argv[1]);
  strcpy(fout,argv[2]);
  strcpy(ftin,fin);
  strcpy(ftout,fout);
  pftin=strrchr(ftin,'.');
  for (i=0; pftin[i]; i++) pftin[i]=toupper(pftin[i]);
  pftout=strrchr(ftout,'.');
  for (i=0; pftout[i]; i++) pftout[i]=toupper(pftout[i]);
  if (!strcmp(pftin, ".ASC") && (argc!=5)) {
    cout << "need sampling rate for ASCII files ! \n";
    goto ende;
  }
  chn=atoi(argv[3]);
  sr =atof(argv[4]);

  cout << "In-File   : " << fin << "\n";
  cout << "Out-File  : " << fout << "\n";
  cout << "Rectify ch: " << chn << "\n";

  /* E i n g a b e d a t e i   o e f f n e n */
  if (strcmp(pftin,".TSA")==0) r.ReadTSA(fin);
  if (strcmp(pftin,".ASC")==0) r.ReadASCII(fin,sr);
  if ((strcmp(pftin,".TSA")!=0) && (strcmp(pftin,".ASC")!=0)) {
    cout << "File type for input not recognized! \n";
    goto ende;
  }
  cout << "Number of channels   : " << r.n << "\n";

  for (i=0; i < r.n; i++)
    cout << "Number of lines in channel : " << i+1 << " " << r.ch[i].n << "\n";

  r.Rectify(chn);

  /* D a t e i   s c h r e i b e n */
  if (strcmp(pftout,".TSA")==0) r.WriteTSA(fout);
  if (strcmp(pftout,".ASC")==0) r.WriteASCII(fout);
  if ((strcmp(pftout,".TSA")!=0) && (strcmp(pftout,".ASC")!=0)) {
    cout << "File type for output not recognized! \n";
    goto ende;
  }

 ende:
  delete [] fin;
  delete [] ftin;
  delete [] fout;
  delete [] ftout;
  return(0);
} /* Ende von main */
